
var pos=startPositions[me]//target
var rpos=pos//repair centre
var state=0

var repairThreshold=40
var repairHigh=.5
var repairLow=.1

var limitHigh=.8
var limitLow=.5

var enemyHigh=36
var enemyLow=24

function dumbState()
{
    var enemy=max(playerData.map((x,i)=>i).filter(i=>!allianceExistsBetween(me,i)),i=>countDroid(DROID_ANY,i)+countStruct("A0LightFactory",i)+countStruct("A0PowerGenerator",i))

    var repairEnabled=countStruct("A0RepairCentre3",me)>0
    if (repairEnabled)rpos=enumStruct(me,"A0RepairCentre3")[0]
   
    var weaponTeam=enumDroid(me,DROID_WEAPON).concat(enumDroid(me,DROID_CYBORG))
    var limitRatio=countDroid(DROID_ANY,me)/ (oilRatio>20?getDroidLimit(me):16+oilRatio*2)
    var repairRatio=repairEnabled ? weaponTeam.filter(weapon=>weapon.health<repairThreshold).length/weaponTeam.length : 0
    var enemyDistance=distBetween(min(enumDroid(enemy),distTo(rpos)),rpos)

    if (gameTime-ptime>5000)
    {
        if (countDroid(enemy)>0)pos=max(enumDroid(enemy),i=>i.cost)
        else 
        {
            var enemyStruct=(oilRatio>20 && enumStruct(enemy,"A0ResourceExtractor"))?enumStruct(enemy).filter(i=>i.cost>25):enumStruct(enemy,"A0ResourceExtractor")
            pos=enemyStruct.length>0?max(enemyStruct,i=>i.cost):rpos
        }

    }

    if (state==0)//defense
    {
        if (enemyDistance < enemyLow ||
            (limitRatio > limitHigh && repairRatio < repairLow)
        ) 
        {
            state=1
        }
    }
    if (state==1)//attack
    {
        if (enemyDistance > enemyHigh &&
            (limitRatio < limitLow || repairRatio > repairHigh || (getResearch("R-Wpn-RailGun01",enemy).done && !getResearch("R-Wpn-RailGun02",me).done && limitRatio < limitHigh ))
        ) state=0
    }
}
setTimer(dumbState.name, 659+me*3);






var ptime=0
/** An event that is run when an object belonging to the script's controlling player is
attacked. The attacker parameter may be either a structure or a droid. 
* @param {_object} victim
* @param {_object} attacker
*/
function eventAttacked(victim, attacker)
{
    if (allianceExistsBetween(attacker.player,me))return
    if (attacker.type==DROID && isVTOL(attacker))return
    if ((gameTime-ptime)>5000)
    {
        ptime=gameTime
        pos=attacker
    }
}




var headRatio=.5// unit ratio
var headThreshold=8// distance
var sortThreshold=24// rank
var healthRatio=.2// unit ratio

function dumbTank()
{
    var weaponTeam=enumDroid(me,DROID_WEAPON).concat(enumDroid(me,DROID_CYBORG))
    //var enemyTeam=enumDroid(enemy,DROID_WEAPON).concat(enumDroid(enemy,DROID_CYBORG))

    if (weaponTeam.length==0)return

    var healthRank=argmap(weaponTeam,weapon=>weapon.health)
    var distanceRank=argmap(weaponTeam,weapon=>distBetween(weapon,rpos))

    var healthArg=argsort(weaponTeam,weapon=>weapon.health)
    var headArg=argsort(weaponTeam,weapon=>distBetween(weapon,pos))
    var headBack=distBetween(weaponTeam[headArg[ parseInt(weaponTeam.length*headRatio) ]],pos)

    var healthThreshold=weaponTeam[healthArg[parseInt(weaponTeam.length*healthRatio)]].health

    if (state==0) weaponTeam.forEach((weapon,i)=>
    {
        if (weapon.health<healthThreshold)
        {
            return orderDroid(weapon,DORDER_RTR)
        }
        else
        {
            if (distBetween(rpos,weapon)<8)return spamMove(weapon)
            else return orderDroid(weapon,DORDER_RTR)
        }
    })

    if (state==1) weaponTeam.forEach((weapon,i)=>
    {
        if (headBack-distBetween(weapon,pos) > headThreshold)return orderDroid(weapon,DORDER_RTR)

        if (weapon.health<80 && weapon.name.includes("MG") && gameTime-weapon.weapons[0].lastFired<3700 && parseInt(weapon.weapons[0].lastFired/500)%2==0)return orderDroid(weapon,DORDER_RTR)
        if (weapon.health<60 && weapon.name.includes("MG") && gameTime-weapon.weapons[0].lastFired<5000)return orderDroid(weapon,DORDER_RTR)
        if (weapon.health<60 && distanceRank[i]-healthRank[i] > sortThreshold && gameTime-weapon.weapons[0].lastFired<2000)return orderDroid(weapon,DORDER_RTR)

        if (weapon.health<repairThreshold)return orderDroid(weapon,DORDER_RTR)

        if (weapon.health>60 && !weapon.name.includes("Cannon375mmMk1" ) && !weapon.name.includes("Rail"))return orderDroidLoc(weapon,DORDER_MOVE,pos.x,pos.y)
        else return orderDroidLoc(weapon,DORDER_PATROL,pos.x,pos.y)
    })

}

setTimer(dumbTank.name, 359+me*3)
