const _core=[
    "A0CommandCentre","A0PowerGenerator","A0ResearchFacility",
    "A0LightFactory","A0CyborgFactory",
    "A0RepairCentre3",
    //"A0VTolFactory1","A0VtolPad",
    "A0Sat-linkCentre","A0LasSatCommand"]
const _coreMod={
    "Research Facility":["A0ResearchModule1",1],
    "Power Generator":["A0PowMod1",1],
    "Factory":["A0FacMod1",2],
    "VTOL Factory":["A0FacMod1",2],
}
const _defense=["X-Super-MassDriver","X-Super-Cannon","Emplacement-Rail3","Emplacement-Rail2","AASite-QuadBof02","AASite-QuadBof","Tower-Projector","PillBox5","A0HardcreteMk1Wall"]
const _defenseAA=["WallTower-SamHvy","P0-AASite-Laser","P0-AASite-SAM1","AASite-QuadBof02","P0-AASite-Sunburst","AASite-QuadMg1","AASite-QuadBof"]
const _sensor=["Sys-SensoTowerWS","Sys-SensoTower02","A0HardcreteMk1Wall"]
const _artillery=["Emplacement-HvART-pit","Emplacement-Howitzer150","Emplacement-Howitzer105","Emplacement-MortarPit02","Emplacement-MortarPit01","A0HardcreteMk1Wall"]


function goodCore(name="")
{
    var x=goodCount(name)
    if (name=="A0CommandCentre")return 0.7
    if (name=="A0ResearchFacility")return x*0.8-.2
    if (name=="A0LightFactory")return x-.21
    if (name=="A0CyborgFactory")return x-.3
    if (name=="A0VtolPad")return 0.6
    if (name=="A0PowerGenerator")return x-.6+playerPower(me)/2500
    return x
}


function dumbTruck()
{
    var truckTeam=enumDroid(me,DROID_CONSTRUCT).filter(truck=>!(truck.action==DACTION_BUILD || truck.action==DACTION_BUILDWANDER)).sort((a,b)=>distBetween(a,home)-distBetween(b,home))
    var oilTeam=enumFeature(ALL_PLAYERS,"OilResource").filter(i=>safeDest(me,i.x,i.y))
    var derrickTeam=enumStruct(me,"A0ResourceExtractor")
    var modTeam=enumStruct(me).filter(i=>i.status ==BUILT && _coreMod[i.name]!==undefined && i.modules<_coreMod[i.name][1]).sort((a,b)=>distBetween(a,home)-distBetween(b,home))

    if (derrickTeam.length<oilLimit && oilTeam.length>0)
    {
        var truckTeam2=truckTeam.splice(truckTeam.length-4,4)
        pair(truckTeam2,oilTeam,distBetween).forEach(([truck,oil])=>{
            orderDroidBuild(truck,DORDER_BUILD,"A0ResourceExtractor",oil.x,oil.y,0)
        })
    }
    
    var struct=_core.find(i=>countStruct(i,me)<getStructureLimit(i,me) && isStructureAvailable(i,me))
    var pos=(struct=="A0RepairCentre3")?{x:home.x*.8+mapWidth/2*.2, y:home.y*.8+mapHeight/2*.2,}:home

    if (struct!==undefined) truckTeam.forEach(truck=>{
        spamBuild(truck,struct,pos)
    })
    else if (modTeam.length>0) truckTeam.forEach(truck=>{
        orderDroidBuild(truck,DORDER_BUILD, _coreMod[modTeam[0].name][0], modTeam[0].x,modTeam[0].y)
    })
    else truckTeam.forEach(truck=>{
        orderDroid(truck,DORDER_RTB)
    })



}

setTimer(dumbTruck.name, 809+me*3);